/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>

/*---------------------------------------------------------------------------------------------------------*/
/*  Include hear file   	    				                                                           */
/*---------------------------------------------------------------------------------------------------------*/

#include "NUC1xx.h"

/*----------------------------------------------------------------------------
  Define variable
  ----------------------------------------------------------------------------*/
	static uint32_t TimerCOUN=0;
/*----------------------------------------------------------------------------
  Function subroutine
  ----------------------------------------------------------------------------*/
void Delay(uint32_t delayCnt)
{
    while(delayCnt--)
    {
        __NOP();
        __NOP();
    }
}
uint32_t GetTDR(void)
{
	return 	TIMER0->TDR;
}
/*----------------------------------------------------------------------------
  Interrupt subroutine
  ----------------------------------------------------------------------------*/
void TMR0_IRQHandler(void) // Timer0 interrupt subroutine 
{
 	TIMER0->TISR.TIF =1; 
	TimerCOUN++;	   
}
/*----------------------------------------------------------------------------
  MAIN function
  ----------------------------------------------------------------------------*/
int32_t main (void)
{
	uint32_t TEMP=0;


	NVIC_DisableIRQ(TMR0_IRQn);	//Disable Timer0 interrupt
	outpw(&TIMER0->TCSR ,0 );	//Disable Timer0                              

	/* Step 1. Enable and Select Timer clock source */          
	SYSCLK->CLKSEL1.TMR0_S = 4;	//Select 22Mhz for Timer0 clock source 
    SYSCLK->APBCLK.TMR0_EN =1;	//Enable Timer0 clock source

	/* Step 2. Select Operation mode */	
	TIMER0->TCSR.MODE=1;		//Select periodic mode for operation mode

	/* Step 3. Select Time out period = (Period of timer clock input) * (8-bit Prescale + 1) * (24-bit TCMP)*/
	TIMER0->TCSR.PRESCALE=0;	// Set Prescale [0~255]
	TIMER0->TCMPR = 2765;		// Set TCMPR [0~16777215]
								// (1/22118400)*(0+1)*(2765)= 125.01usec or 7999.42Hz

	/* Step 4. Enable interrupt */
	TIMER0->TCSR.IE = 1;
	TIMER0->TISR.TIF = 1;		//Write 1 to clear for safty		
	NVIC_EnableIRQ(TMR0_IRQn);	//Enable Timer0 Interrupt

	/* Step 5. Enable Timer module */
	TIMER0->TCSR.CRST = 1;		//Reset up counter
	TIMER0->TCSR.CEN = 1;		//Enable Timer0

  	TIMER0->TCSR.TDR_EN=1;		// Enable TDR function

	while(1)
	{
		Delay(1000);
		TEMP = GetTDR();		//Get value of up counter

		if (TimerCOUN>40000) break;	//Wait 5 seconds
	}

	NVIC_DisableIRQ(TMR0_IRQn);	//Disable Timer0 interrupt
	outpw(&TIMER0->TCSR ,0 );	//Disable Timer0  
  
    while(1);
}





